'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.EMBModuler = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _gcl = require('gcl');

var _gcl2 = _interopRequireDefault(_gcl);

var _vesh = require('vesh');

var _vesh2 = _interopRequireDefault(_vesh);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * EMB扩展NiModuler(crypt,middler[,appname:"Ni"]),监听_m参数(等价_n),自动协助EMBAutoFactory完成SQL生成和数据查询服务和增删改三个操作
 * 按照如下优先级进行命令查找，不可跨操作级别操作，不可无权限操作
 * 
 * 表结构级别
 *      库.表.类型.操作
 *      库.表.类型.*
 *      库.表.*.操作
 *      库.*.类型.操作
 *      库.*.*.操作
 *      库.*.*.*
 * 表数据级别
 *      库.表.操作
 *      库.表.edit
 *      库.*.edit
 *      库.表.nodel
 *      库.*.nodel
 *      库.*.操作
 *      库.表.*
 *      库.*.*
 * 库级别
 *      库.操作
 *      库.*
 *      *.操作
 * 
 */
var EMBModuler = exports.EMBModuler = function (_C$AModuler) {
    (0, _inherits3.default)(EMBModuler, _C$AModuler);

    function EMBModuler(middler) {
        var appname = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "Ni";
        var prefix = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
        (0, _classCallCheck3.default)(this, EMBModuler);

        //兼容旧类参数的定义 将原有的crypt类实例删除赋值
        var _this = (0, _possibleConstructorReturn3.default)(this, (EMBModuler.__proto__ || (0, _getPrototypeOf2.default)(EMBModuler)).call(this, "EMBModuler"));

        (arguments.length > 3 || middler.encrypt) && (middler = appname, appname = prefix, prefix = arguments[3]);

        var _pri = pri(_this, {
            middler: middler,
            prefix: prefix,
            ni: middler ? new _gcl2.default.NiTemplateManager(middler, appname) : function () {
                throw new Error('必须定义中介者middler对象');
            }(),
            idic: {},
            getCommand: function () {
                var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(templatename, command) {
                    var cmd;
                    return _regenerator2.default.wrap(function _callee$(_context) {
                        while (1) {
                            switch (_context.prev = _context.next) {
                                case 0:
                                    command = __.prefix + command;

                                    if (!__.idic[command]) {
                                        _context.next = 7;
                                        break;
                                    }

                                    _context.next = 4;
                                    return __.ni.getCommand(templatename, command);

                                case 4:
                                    return _context.abrupt('return', _context.sent);

                                case 7:
                                    if (!(typeof __.idic[command] == 'undefined')) {
                                        _context.next = 15;
                                        break;
                                    }

                                    _context.next = 10;
                                    return __.ni.getCommand(templatename, command);

                                case 10:
                                    cmd = _context.sent;

                                    __.idic[command] = !!cmd;
                                    return _context.abrupt('return', cmd);

                                case 15:
                                    return _context.abrupt('return', null);

                                case 16:
                                case 'end':
                                    return _context.stop();
                            }
                        }
                    }, _callee, this);
                }));

                function getCommand(_x3, _x4) {
                    return _ref.apply(this, arguments);
                }

                return getCommand;
            }()
        }),
            _ = _pri._,
            __ = _pri.__;

        return _this;
    }

    (0, _createClass3.default)(EMBModuler, [{
        key: 'onrequest',
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(req, rep, session) {
                var _this2 = this;

                var _pri2, _, __, templatename, cmd, methodname, method, pers, hasRight, cmdparams, k, v;

                return _regenerator2.default.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                _pri2 = pri(this), _ = _pri2._, __ = _pri2.__;
                                _context3.prev = 1;

                                if (!session.param('_m')) {
                                    _context3.next = 129;
                                    break;
                                }

                                templatename = session.param('_m');
                                //第三方或者我方自己调用都需要权限

                                if (session.User.Login) {
                                    _context3.next = 6;
                                    break;
                                }

                                throw new Error(session.methodname + '\u6267\u884C\u9700\u8981\u767B\u5F55\u6267\u884C!');

                            case 6:
                                session.querystring['_n'] = session.param('_m');
                                session.querystring && delete session.querystring['_m'];
                                session.form && (delete session.form['_m'], delete session.form['_n']);
                                //先判断是否有已经设置的正常SQL操作,如有那么直接设置执行正常SQL否则进行
                                cmd = null;

                                if (!(session.methodname.indexOf('*') < 0)) {
                                    _context3.next = 103;
                                    break;
                                }

                                _context3.next = 13;
                                return __.getCommand(templatename, session.methodname);

                            case 13:
                                cmd = _context3.sent;

                                if (!(!cmd.params && !cmd.command)) {
                                    _context3.next = 103;
                                    break;
                                }

                                //确认为第三方调用 进行方法名解析 并重构命令名
                                methodname = ('' + session.url.pathname.substr(0, session.url.pathname.lastIndexOf(session.filename)) + session.status).replace(/[\\\/]/g, '.').toLowerCase().trim('.').split('.');

                                session.methodname = methodname.join('.');
                                method = methodname[methodname.length - 1];
                                //过滤所有路径中带*的操作
                                /**
                                 * 原文长度 
                                 *      库.表.类型.操作
                                 *      库.表.类型.*
                                 *      库.表.*.操作
                                 *      库.*.类型.操作
                                 *      库.*.*.操作
                                 *      库.*.*.*
                                 * 
                                 *      库.表.操作
                                 *      库.表.edit
                                 *      库.*.edit
                                 *      库.表.nodel
                                 *      库.*.nodel
                                 *      库.*.操作
                                 *      库.表.*(不含del drop truncate)
                                 *      库.*.*(不含del drop truncate)
                                 * 
                                 *      库.操作
                                 *      库.*
                                 *      *.操作
                                 */

                                _context3.next = 20;
                                return __.getCommand(templatename, methodname.join('.'));

                            case 20:
                                cmd = _context3.sent;

                                if (!(!(cmd.params || cmd.command) && methodname.length != 3)) {
                                    _context3.next = 25;
                                    break;
                                }

                                _context3.next = 24;
                                return __.getCommand(templatename, methodname.map(function (v, i) {
                                    return i == methodname.length - 1 ? '*' : v;
                                }).join('.'));

                            case 24:
                                cmd = _context3.sent;

                            case 25:
                                if (cmd.params || cmd.command) {
                                    _context3.next = 103;
                                    break;
                                }

                                _context3.t0 = methodname.length;
                                _context3.next = _context3.t0 === 4 ? 29 : _context3.t0 === 3 ? 56 : _context3.t0 === 2 ? 97 : 103;
                                break;

                            case 29:
                                _context3.next = 31;
                                return __.getCommand(templatename, methodname.map(function (v, i) {
                                    return i == 2 ? '*' : v;
                                }).join('.'));

                            case 31:
                                cmd = _context3.sent;

                                if (!(cmd.params || cmd.command)) {
                                    _context3.next = 34;
                                    break;
                                }

                                return _context3.abrupt('break', 103);

                            case 34:
                                _context3.next = 36;
                                return __.getCommand(templatename, methodname.map(function (v, i) {
                                    return i == 1 ? '*' : v;
                                }).join('.'));

                            case 36:
                                cmd = _context3.sent;

                                if (!(cmd.params || cmd.command)) {
                                    _context3.next = 39;
                                    break;
                                }

                                return _context3.abrupt('break', 103);

                            case 39:
                                _context3.next = 41;
                                return __.getCommand(templatename, methodname.map(function (v, i) {
                                    return i == 1 || i == 2 ? '*' : v;
                                }).join('.'));

                            case 41:
                                cmd = _context3.sent;

                                if (!(cmd.params || cmd.command)) {
                                    _context3.next = 44;
                                    break;
                                }

                                return _context3.abrupt('break', 103);

                            case 44:
                                if (method.eq('drop')) {
                                    _context3.next = 50;
                                    break;
                                }

                                _context3.next = 47;
                                return __.getCommand(templatename, methodname[0] + '.*.*.nodel');

                            case 47:
                                cmd = _context3.sent;

                                if (!(cmd.params || cmd.command)) {
                                    _context3.next = 50;
                                    break;
                                }

                                return _context3.abrupt('break', 103);

                            case 50:
                                _context3.next = 52;
                                return __.getCommand(templatename, methodname[0] + '.*.*.*');

                            case 52:
                                cmd = _context3.sent;

                                if (!(cmd.params || cmd.command)) {
                                    _context3.next = 55;
                                    break;
                                }

                                return _context3.abrupt('break', 103);

                            case 55:
                                return _context3.abrupt('break', 103);

                            case 56:
                                if (!(!method.eq('select') && !method.eq('count') && !method.eq('sum'))) {
                                    _context3.next = 81;
                                    break;
                                }

                                _context3.next = 59;
                                return __.getCommand(templatename, methodname.map(function (v, i) {
                                    return i == methodname.length - 1 ? 'edit' : v;
                                }).join('.'));

                            case 59:
                                cmd = _context3.sent;

                                if (!(cmd.params || cmd.command)) {
                                    _context3.next = 62;
                                    break;
                                }

                                return _context3.abrupt('break', 103);

                            case 62:
                                _context3.next = 64;
                                return __.getCommand(templatename, methodname[0] + '.*.edit');

                            case 64:
                                cmd = _context3.sent;

                                if (!(cmd.params || cmd.command)) {
                                    _context3.next = 67;
                                    break;
                                }

                                return _context3.abrupt('break', 103);

                            case 67:
                                if (!(!method.eq('drop') && !method.eq('del') && !method.eq('truncate'))) {
                                    _context3.next = 80;
                                    break;
                                }

                                _context3.next = 70;
                                return __.getCommand(templatename, methodname.map(function (v, i) {
                                    return i == methodname.length - 1 ? 'nodel' : v;
                                }).join('.'));

                            case 70:
                                cmd = _context3.sent;

                                if (!(cmd.params || cmd.command)) {
                                    _context3.next = 73;
                                    break;
                                }

                                return _context3.abrupt('break', 103);

                            case 73:
                                _context3.next = 75;
                                return __.getCommand(templatename, methodname[0] + '.*.nodel');

                            case 75:
                                cmd = _context3.sent;

                                if (!(cmd.params || cmd.command)) {
                                    _context3.next = 78;
                                    break;
                                }

                                return _context3.abrupt('break', 103);

                            case 78:
                                _context3.next = 81;
                                break;

                            case 80:
                                return _context3.abrupt('break', 103);

                            case 81:
                                _context3.next = 83;
                                return __.getCommand(templatename, methodname.map(function (v, i) {
                                    return i == 1 ? '*' : v;
                                }).join('.'));

                            case 83:
                                cmd = _context3.sent;

                                if (!(cmd.params || cmd.command)) {
                                    _context3.next = 86;
                                    break;
                                }

                                return _context3.abrupt('break', 103);

                            case 86:
                                _context3.next = 88;
                                return __.getCommand(templatename, methodname.map(function (v, i) {
                                    return i == methodname.length - 1 ? '*' : v;
                                }).join('.'));

                            case 88:
                                cmd = _context3.sent;

                                if (!(cmd.params || cmd.command)) {
                                    _context3.next = 91;
                                    break;
                                }

                                return _context3.abrupt('break', 103);

                            case 91:
                                _context3.next = 93;
                                return __.getCommand(templatename, methodname[0] + '.*.*');

                            case 93:
                                cmd = _context3.sent;

                                if (!(cmd.params || cmd.command)) {
                                    _context3.next = 96;
                                    break;
                                }

                                return _context3.abrupt('break', 103);

                            case 96:
                                return _context3.abrupt('break', 103);

                            case 97:
                                _context3.next = 99;
                                return __.getCommand(templatename, '*.' + methodname[1]);

                            case 99:
                                cmd = _context3.sent;

                                if (!(cmd.params || cmd.command)) {
                                    _context3.next = 102;
                                    break;
                                }

                                return _context3.abrupt('break', 103);

                            case 102:
                                return _context3.abrupt('break', 103);

                            case 103:
                                if (!(cmd && (cmd.params || cmd.command))) {
                                    _context3.next = 128;
                                    break;
                                }

                                if (cmd.params['_TestPermission']) {
                                    _context3.next = 106;
                                    break;
                                }

                                throw new Error(session.methodname + '\u6267\u884C\u9700\u8981\u6743\u9650\u624D\u80FD\u6267\u884C!');

                            case 106:
                                pers = (cmd.params['_TestPermission'].value || '').split(',').filter(function (v) {
                                    return v.length > 0;
                                });
                                hasRight = false;
                                _context3.next = 110;
                                return _gcl2.default.each(pers, function () {
                                    var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(v, call) {
                                        return _regenerator2.default.wrap(function _callee2$(_context2) {
                                            while (1) {
                                                switch (_context2.prev = _context2.next) {
                                                    case 0:
                                                        _context2.next = 2;
                                                        return session.hasRight(v);

                                                    case 2:
                                                        if (!_context2.sent) {
                                                            _context2.next = 4;
                                                            break;
                                                        }

                                                        hasRight = true;

                                                    case 4:
                                                        return _context2.abrupt('return', false);

                                                    case 5:
                                                    case 'end':
                                                        return _context2.stop();
                                                }
                                            }
                                        }, _callee2, _this2);
                                    }));

                                    return function (_x8, _x9) {
                                        return _ref3.apply(this, arguments);
                                    };
                                }(), true);

                            case 110:
                                if (!(pers.length > 0 && !hasRight)) {
                                    _context3.next = 112;
                                    break;
                                }

                                throw new Error(session.methodname + '\u6267\u884C\u9700\u8981' + cmd.params['_TestPermission'].value + '\u6743\u9650!');

                            case 112:
                                //数据源重置 防止无法找到对应的方法执行错误
                                session.querystring['_n'] = cmd.template || session.querystring['_n'];
                                cmdparams = {};
                                _context3.t1 = _regenerator2.default.keys(cmd.params);

                            case 115:
                                if ((_context3.t2 = _context3.t1()).done) {
                                    _context3.next = 124;
                                    break;
                                }

                                k = _context3.t2.value;
                                v = cmd.params[k];

                                v = (v ? v.value || (typeof v == 'string' ? v : "") : '') + '';
                                cmd.params[k] && cmd.params[k].value !== undefined && (cmdparams[k] = v);

                                if (!(!k.match(/^[_\?]/) && cmd.params[k].value === undefined && session.form[k] === undefined)) {
                                    _context3.next = 122;
                                    break;
                                }

                                throw new Error(k + '\u8981\u6C42\u4E3A\u5FC5\u586B!');

                            case 122:
                                _context3.next = 115;
                                break;

                            case 124:
                                //命令重置
                                session.methodname = _gcl2.default.getValue(cmd.command, session.methodname);
                                //强制某些命令的条件限制
                                session.form = _gcl2.default.merge(session.form || {}, cmdparams);
                                _context3.next = 129;
                                break;

                            case 128:
                                throw new Error(session.methodname + '\u6267\u884C\u9700\u8981\u8BBE\u7F6E\u6743\u9650\u6267\u884C!');

                            case 129:
                                _context3.next = 135;
                                break;

                            case 131:
                                _context3.prev = 131;
                                _context3.t3 = _context3['catch'](1);

                                console.log('EMBModuler', _context3.t3.stack);
                                throw _context3.t3;

                            case 135:
                                return _context3.abrupt('return', false);

                            case 136:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this, [[1, 131]]);
            }));

            function onrequest(_x5, _x6, _x7) {
                return _ref2.apply(this, arguments);
            }

            return onrequest;
        }()
    }]);
    return EMBModuler;
}(_vesh2.default.AModuler);

exports.default = {
    EMBModuler: EMBModuler
};

var pri = _gcl2.default.pris();
//# sourceMappingURL=EMBModuler.js.map