"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EMBMySQLConverter = undefined;

var _isInteger = require("babel-runtime/core-js/number/is-integer");

var _isInteger2 = _interopRequireDefault(_isInteger);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _gcl = require("gcl");

var _gcl2 = _interopRequireDefault(_gcl);

var _vesh = require("vesh");

var _vesh2 = _interopRequireDefault(_vesh);

var _querystring = require("querystring");

var _querystring2 = _interopRequireDefault(_querystring);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * MySQL库表转换器
 * >
 * >=
 * <
 * <=
 * =
 * !=
 * ~= in
 * !~= not in
 * @= find_in_set
 * !@= not find_in_set
 * %= like
 * !%= not like
 * && and 嵌套
 * || or 嵌套
 */
var EMBMySQLConverter = exports.EMBMySQLConverter = function () {
  function EMBMySQLConverter() {
    var isStrict = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    (0, _classCallCheck3.default)(this, EMBMySQLConverter);

    var _pri = pri(this, {
      opes: {},
      isStrict: isStrict,
      // getValue: v => ((v ? ((v.value !== undefined && v.value !== null) ? v.value : (v || '')) : '') + '').replace(/;/g, '_'),
      getValue: function getValue(v) {
        return ((v != undefined ? v.value !== undefined && v.value !== null ? v.value : v : "") + "").replace(/;/g, "_");
      },
      tindex: "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z".split(","),
      jopes: {
        "+": "inner join",
        ">+": "left join",
        "<+": "right join",
        ",": ","
      },
      getTable: function getTable(database, table, params) {
        var opes = table.match(/[<>]?\+|\,/g);
        if (opes) {
          var tables = table.split(/[<>]?\+|\,/);
          if (tables.length > 26) throw new Error("连接表过多");
          if (tables.length - 1 != opes.length) throw new Error("连接符不匹配表数!");
          var nojoin = table.match(/\,/g);
          var options = [];
          if (!nojoin) {
            if (!params["+"]) throw new Error("缺少+参数作为on条件");
            options = eval("[" + __.getValue(params["+"]) + "]")[0];
            delete params["+"];
            if (options.length != opes.length) throw new Error("连接条件不匹配表数!");
          } else if (params["+"]) {
            options = eval("[" + __.getValue(params["+"]) + "]")[0];
            delete params["+"];
            if (options.length != opes.length) throw new Error("连接条件不匹配表数!");
            options.forEach(function (v) {
              for (var k in v) {
                params[k] = { value: v[k], isStandard: true };
              }
            });
          }

          var sb2 = _gcl2.default.sb();
          //+ jion <+ right join >+ left join
          tables.forEach(function (v, i) {
            if (i > 0) sb2.append(!nojoin ? " " + __.jopes[opes[i - 1]] + " " : ",");
            sb2.append("" + (database ? "." + database : "") + v).append(" " + __.tindex[i] + " ");
            if (!nojoin && i > 0) sb2.append("on ").append(_.getOpe(options[i - 1], "and"));
          });
          var ret = sb2.clear();
          sb2 = null;
          return ret;
        } else if (table.match(/\|/g)) return "{tablename}";else return "" + (database ? database + "." : "") + table;
      }
    }),
        _ = _pri._,
        __ = _pri.__;

    ">,>=,=,<=,<,!=,~=,!~=,@,!@,@=,!@=,%=,!%=,&&,||,+,(".split(",").forEach(function (v) {
      return __.opes[v] = true;
    });
  }

  (0, _createClass3.default)(EMBMySQLConverter, [{
    key: "getWhere",
    value: function getWhere(params) {
      var onlywhere = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var _pri2 = pri(this),
          __ = _pri2.__;

      var paraname = {};
      for (var i in params) {
        if (params[i] !== undefined && params[i].value !== undefined) paraname[i.toLowerCase()] = params[i];
      } /**
         * 需要判断
         * _and
         * _or
         * _count
         * _order
         * _group
         * _page
         * todo or 和 and 不全 缺少对~/* /* /或者~/* /的辅助
         */
      var sb = _gcl2.default.sb();
      try {
        sb.append(this.getOpe(params, "and"));
        if (!_gcl2.default.isValid(sb.toString())) sb.append(" 1=1 ");
        if (!onlywhere) {
          if (__.getValue(paraname["_group"])) sb.append(" group by " + __.getValue(paraname["_group"]) + " ");
          if (__.getValue(paraname["_order"])) sb.append(" order by " + __.getValue(paraname["_order"]) + " ");
          if (__.getValue(paraname["_orderby"])) sb.append(" order by " + __.getValue(paraname["_orderby"]) + " ");
          if (__.getValue(paraname["_page"])) sb.append(" limit " + __.getValue(paraname["_page"]).replace(/\s/g, "") + " ");
          if (__.getValue(paraname["_limit"])) sb.append(" limit " + __.getValue(paraname["_limit"]).replace(/\s/g, "") + " ");
        } else if (onlywhere === 2 && (__.getValue(paraname["_page"]) || __.getValue(paraname["_limit"]))) sb.append(" limit " + parseInt((__.getValue(paraname["_page"]) || __.getValue(paraname["_limit"])).replace(/\s/g, "")) + " ");

        return sb.clear();
      } finally {
        sb = null;
      }
    }

    /**
     * @test name (a,b)=>11
     * @test name (a,b)=>11
     * @param {*} params
     * @param {*} split
     */

  }, {
    key: "getOpe",
    value: function getOpe(params, split) {
      var _pri3 = pri(this),
          _ = _pri3._,
          __ = _pri3.__;

      var sb = _gcl2.default.sb();
      try {
        for (var k in params) {
          if (params[k] === undefined || params[k].isStandard !== undefined && params[k].value === undefined) continue;
          k = k.trim();
          if (k.startsWith("_") || !k.eq("+") && !k.eq("&&") && !k.eq("||") && !k.startsWith("$")) continue;

          var v = __.getValue(params[k]);
          if (typeof v == "string" && v.indexOf("?_NULL") >= 0 && !params["_NULL"]) {
            params["_NULL"] = { value: null, isStandard: true };
          }
          var i = 3;
          //有问题
          //if (!params[k.substr(1)]) params[k.substr(1)] = params[k];
          delete params[k];
          if (__.opes[k] || __.opes[v.toLowerCase().substr(0, i--)] || __.opes[v.toLowerCase().substr(0, i--)] || __.opes[v.substr(0, i--)]) {
            var ope = i == 3 ? k : v.substr(0, i + 1).toLowerCase();
            k = k.substr(1);
            switch (ope) {
              case "(":
                sb.append(" " + v + " ");
                break;
              case "+":
                //为on 特别准备 如果没有删除 那么说应需要在where中出现
                var options = eval("[" + params[ope] + "]")[0];
                options.forEach(function (v, i) {
                  sb.append(_.getOpe(v, "and"));
                });
                break;
              case ">":
              case ">=":
              case "<":
              case "<=":
              case "!=":
                sb.append(" " + (k.startsWith("?") || k.indexOf(".") >= 0 ? k : "`" + k + "`") + " " + ope);
                //k.match(/\./) ||
                if (!v.startsWith("'") && !v.startsWith('"') && !!v.match(/\(|(\?[^,])|\+|\-|\*|\.|\/|`/)) sb.append(v.substr(ope.length));else if (params[k] || v.indexOf("`") >= 0) sb.append("" + (v.indexOf("`") < 0 ? "'" + v.substr(ope.length).trim('"').trim("'") + "'" : v.substr(ope.length)));else {
                  k = "_" + k.replace(/\./g, "_") + _gcl2.default.random();
                  sb.append("?" + k);
                  params[k] = {
                    value: v.substr(ope.length).trim('"').trim("'"),
                    isStandard: true
                  };
                }
                break;
              default:
                sb.append(" " + (k.startsWith("?") || k.indexOf(".") >= 0 ? "ifnull(" + k + ",'')" : "`" + k + "`") + " ");
                if ("?_NULL".eq(v)) {
                  sb.append("is NULL");
                } else {
                  sb.append(ope + " ifnull(");
                  //k.match(/\./) ||
                  if (!v.startsWith("'") && !v.startsWith('"') && !!v.match(/\(|(\?[^,])|\+|\-|\*|\.|\/|`/)) sb.append(v.substr(ope.length));else if (params[k] || v.indexOf("`") >= 0) sb.append("" + (v.indexOf("`") < 0 ? "'" + v.substr(ope.length).trim('"').trim("'") + "'" : v.substr(ope.length)));else {
                    k = "_" + k.replace(/\./g, "_") + _gcl2.default.random();
                    sb.append("?" + k);
                    params[k] = {
                      value: v.substr(ope.length).trim('"').trim("'"),
                      isStandard: true
                    };
                  }
                }
                break;
              case "~=":
                //.replace(/[\(\)]/g, '')
                sb.append(" " + (k.startsWith("?") || k.indexOf(".") >= 0 ? k : "`" + k + "`") + " in (").append(v.substr(2).split(",").map(function (v2) {
                  return v2.startsWith("?") || v2.startsWith("`") || v2.startsWith("'") || v2.startsWith('"') || v2.indexOf(".") >= 0 ? v2 : "'" + v2 + "'";
                }).join(",")).append(")");
                break;
              case "!~=":
                //.replace(/[\(\)]/g, '')
                sb.append(" " + (k.startsWith("?") || k.indexOf(".") >= 0 ? k : "`" + k + "`") + " not in (").append(v.substr(3).split(",").map(function (v2) {
                  return v2.startsWith("?") || v2.startsWith("`") || v2.startsWith("'") || v2.startsWith('"') || v2.indexOf(".") >= 0 ? v2 : "'" + v2 + "'";
                }).join(",")).append(")");
                break;
              case "@":
                //.replace(/[\(\)]/g, '')
                sb.append(" " + (k.startsWith("?") || k.indexOf(".") >= 0 ? k : "`" + k + "`") + " between " + v.substr(1).split("|").map(function (v2) {
                  return v2.startsWith("?") || v2.startsWith("`") || v2.startsWith("'") || v2.startsWith('"') || v2.indexOf(".") >= 0 ? v2 : "'" + v2 + "'";
                }).join(" and ") + " ");
                break;
              case "!@":
                //.replace(/[\(\)]/g, '')
                sb.append(" " + (k.startsWith("?") || k.indexOf(".") >= 0 ? k : "`" + k + "`") + " not between " + v.substr(2).split("|").map(function (v2) {
                  return v2.startsWith("?") || v2.startsWith("`") || v2.startsWith("'") || v2.startsWith('"') || v2.indexOf(".") >= 0 ? v2 : "'" + v2 + "'";
                }).join(" and ") + " ");
                break;
              case "@=":
                sb.append(" find_in_set(" + ((v.endWith("`") ? "" : '"') + v.substr(2).replace(/['"]/g, '"') + (v.endWith("`") ? "" : '"')) + "," + (k.startsWith("?") || k.indexOf(".") >= 0 ? k : "`" + k + "`") + ")>0");
                break;
              case "!@=":
                sb.append(" find_in_set(" + ((v.endWith("`") ? "" : '"') + v.substr(3).replace(/['"]/g, '"') + (v.endWith("`") ? "" : '"')) + "," + (k.startsWith("?") || k.indexOf(".") >= 0 ? k : "`" + k + "`") + ")<=0");
                break;
              case "%=":
                sb.append(" " + (k.startsWith("?") || k.indexOf(".") >= 0 ? k : "`" + k + "`") + " like concat('%','" + v.substr(2).trim("'").trim('"').replace(/'/g, "\\'") + "','%')");
                break;
              case "!%=":
                sb.append(" " + (k.startsWith("?") || k.indexOf(".") >= 0 ? k : "`" + k + "`") + " not like concat('%','" + v.substr(3).trim("'").trim('"').replace(/'/g, "\\'") + "','%')");
                break;
              case "&&":
                {
                  (function () {
                    var opes = eval("[" + v.trim() + "]")[0];
                    if (!_gcl2.default.isArray(opes)) opes = [opes];
                    sb.append(" (");
                    opes.forEach(function (v, i) {
                      sb.append(_.getOpe(v, "and"));
                      for (var k2 in v) {
                        if (k2.startsWith("_")) params[k2] = v[k2];
                        //参数设定补偿
                      }
                      if (i < opes.length - 1) sb.append(" and ");
                    });
                    sb.append(" )");
                    //保证适配性更好
                  })();
                }
                break;
              case "||":
                {
                  (function () {
                    var opes = eval("[" + v.trim() + "]")[0];
                    if (!_gcl2.default.isArray(opes)) opes = [opes];
                    sb.append(" (");
                    opes.forEach(function (v, i) {
                      sb.append(_.getOpe(v, "or"));
                      for (var k2 in v) {
                        if (k2.startsWith("_")) params[k2] = v[k2];
                        //参数设定补偿
                      }
                      if (i < opes.length - 1) sb.append(" or ");
                    });
                    sb.append(" )");
                    //保证适配性更好
                  })();
                }
                break;
            }
          } else {
            k = k.substr(1);

            sb.append(" " + (k.startsWith("?") || k.indexOf(".") >= 0 ? "ifnull(" + k + ",'')" : "`" + k + "`") + " ");

            if ("?_NULL".eq(v)) {
              sb.append(" is NULL");
            } else {
              sb.append("= ifnull(");
              //k.match(/\./) ||
              if (!v.startsWith("'") && !v.startsWith('"') && !!v.match(/\(|(\?[^,])|\+|\-|\*|\.|\/|`/)) sb.append(v);else if (params[k] || v.indexOf("`") >= 0) sb.append(v.indexOf("`") < 0 ? "'" + v.trim("'").trim('"') + "'" : v);else {
                k = "_" + k.replace(/[\.\?\$]/g, "_") + _gcl2.default.random();
                sb.append("?" + k);
                params[k] = { value: v.trim('"').trim("'"), isStandard: true };
              }
              sb.append(",'')");
            }
          }
          sb.append(" " + split + " ");
        }
        return sb.clear().trim(" " + split + " ");
      } finally {
        sb = null;
      }
    }
  }, {
    key: "lstParams",
    value: function lstParams(params, func) {
      var split = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : ",";

      var sb = _gcl2.default.sb();
      try {
        for (var k in params) {
          var v = params[k];
          !k.startsWith("_") && !k.startsWith("$") && k.indexOf(";") < 0 && typeof v != "function" && sb.append(func(k, v)).append(split);
        }
        return sb.clear().trim(split);
      } finally {
        sb = null;
      }
    }
  }, {
    key: "convert",
    value: function convert(cmd) {
      var _pri4 = pri(this),
          _ = _pri4._,
          __ = _pri4.__;

      var that = this;
      var command = cmd.command || "",
          params = cmd.params,
          paraname = {};
      for (var i in params) {
        //防止注入
        if (!!i.match(/\(|;/)) delete params[i];else paraname[i.toLowerCase()] = params[i];
      }
      var cmds = command.replace(/[\\\/]/g, ".").split(".");
      var sb = _gcl2.default.sb();
      //const ID = params._ID || params._IID; //_IID:自增AutoIncrease ID
      try {
        switch (cmds.length) {
          case 4:
            {
              /**
               * id 主键
               * column 修改表
               * index 索引
               * add
               * drop
               */
              var database = cmds[0].replace(/^[~_\.]$/, ""),
                  table = cmds[1],
                  obj = cmds[2].toLowerCase(),
                  method = cmds[3];
              switch (method.toLowerCase()) {
                case "drop":
                  database.length && sb.append("use " + database + ";");
                  sb.append("alter table " + table + " ");
                  if (obj.eq("index")) {
                    var names = [];
                    for (var k in params) {
                      if (!k.startsWith("$") && !k.startsWith("_")) names.push(k.toLowerCase());
                    }names.sort();
                    sb.append(" drop " + obj + " IX_" + _gcl2.default.hash(names.join(","))).append(";select 1 as count;");
                    names = null;
                  } else if (obj.eq("id")) {
                    sb.append(" drop primary key;select 1 as count;");
                  } else if (obj.eq("part")) {
                    sb.append(that.lstParams(params, function (k, v) {
                      return " drop PARTITION `" + k + "`";
                    })).append(";select 1 as count;");
                  } else sb.append(that.lstParams(params, function (k, v) {
                    return " drop " + obj + " `" + k + "`";
                  })).append(";select 1 as count;");
                  break;
                case "change":
                  database.length && sb.append("use " + database + ";");
                  if (obj.eq("index")) {
                    var _names = [];
                    for (var k in params) {
                      if (!k.startsWith("$") && !k.startsWith("_")) _names.push(k.toLowerCase());
                    }_names.sort();
                    sb.append("alter table " + table + " drop index ").append("IX_" + _gcl2.default.hash(_names.join(","))).append(";alter table " + table + " add " + (params["_unique"] ? "UNIQUE" : "") + " " + obj + " ").append("IX_" + _gcl2.default.hash(_names.join(","))).append("(").append(that.lstParams(params, function (k, v) {
                      return k + " " + (__.getValue(v) || "ASC");
                    })).append(");select 1 as count;");
                    _names = null;
                  } else if (obj.eq("id")) {
                    if (!__.getValue(paraname["_id"])) throw new Error("请输入_ID参数");
                    sb.append("alter table " + table + " drop primary key,add PRIMARY KEY(" + __.getValue(paraname["_id"]).replace(/\+/g, ",") + ");").append("select 1 as count;");
                  } else if (obj.eq("part")) {
                    //(' REORGANIZE PARTITION (');
                    //todo 过于复杂暂时中止
                  } else sb.append("alter table " + table + " ").append(that.lstParams(params, function (k, v) {
                    return " change `" + k + "` `" + k + "` " + __.getValue(v);
                  })).append(";select 1 as count;");
                  break;
                case "add":
                  database.length && sb.append("use " + database + ";");
                  sb.append("alter table " + table);
                  if (obj.eq("index")) {
                    var _names2 = [];
                    for (var k in params) {
                      if (!k.startsWith("$") && !k.startsWith("_")) _names2.push(k.toLowerCase());
                    }_names2.sort();
                    sb.append(" add " + (params["_unique"] ? "UNIQUE" : "") + " " + obj + " IX_" + _gcl2.default.hash(_names2.join(","))).append("(").append(that.lstParams(params, function (k, v) {
                      return k + " " + (__.getValue(v) || "ASC");
                    })).append(");select 1 as count;");
                    _names2 = null;
                  } else if (obj.eq("id")) {
                    if (!__.getValue(paraname["_id"])) throw new Error("请输入_ID参数");
                    sb.append(" add PRIMARY KEY(" + __.getValue(paraname["_id"]).replace(/\+/g, ",") + ");").append("select 1 as count;");
                  } else if (obj.eq("part")) {
                    sb.append(" ADD PARTITION (");
                    if (_gcl2.default.isValid(paraname["range"])) {
                      var parts = __.getValue(paraname["range"]).split(/[;,]/g);
                      var index = parseInt(__.getValue(paraname["index"])) || 0;
                      sb.append(parts.map(function (v, i) {
                        return "PARTITION P" + (index + i) + " VALUES LESS THAN (" + v + ")";
                      }).join(","));
                    } else if (_gcl2.default.isValid(paraname["list"])) {
                      var _parts = __.getValue(paraname["list"]).split(/[;,]/g);
                      var _index = parseInt(__.getValue(paraname["index"])) || 0;
                      sb.append(_parts.map(function (v, i) {
                        return "PARTITION P" + (_index + i) + " VALUES IN (" + v + ")";
                      }).join(","));
                    }
                    sb.append(");select 1 as count;");
                  } else sb.append(that.lstParams(params, function (k, v) {
                    return " add " + obj + " `" + k + "` " + (__.getValue(v) || "VARCHAR(32)");
                  })).append(";select 1 as count;");
                  break;
                default:
                  throw new Error("未识别的命令" + command);
              }
            }
            break;
          case 3:
            /**
             * 库名/表名/操作
             * create 建表
             * drop 删除表
             * add 增加数据
             * del 删除数据
             * update 修改数据? 同名字段
             * select 查询数据
             * count 查询数据
             * sum 查询数据
             * edit 指明select,count,sum之外的操作
             * truncate
             * //todo replace
             */
            {
              var _database = cmds[0].replace(/^[~_\.]$/, ""),
                  _table2 = cmds[1],
                  _method = cmds[2];
              switch (_method.toLowerCase()) {
                case "create":
                  _database.length && sb.append("use " + _database + ";");
                  sb.append("create table if not exists " + _table2 + "(").append(that.lstParams(params, function (k, v) {
                    return k + " " + (__.getValue(v) || "VARCHAR(32)");
                  }));
                  if (_gcl2.default.isValid(paraname["_id"])) sb.append(",PRIMARY KEY(" + __.getValue(paraname["_id"]).replace(/\+/g, ",") + ")");
                  if (_gcl2.default.isValid(paraname["_index"])) __.getValue(paraname["_index"]).split(",").map(function (v) {
                    return sb.append(",INDEX IX_" + _gcl2.default.hash(v) + "(" + v.replace(/\+/g, ",") + ")");
                  });
                  sb.append(") ENGINE = INNODB CHARACTER SET utf8 COLLATE utf8_general_ci");
                  var subpart = "";
                  if (_gcl2.default.isValid(paraname["_subpart"])) {
                    //_subpart:list:asbd,1,2,34;5,6,7
                    //_subpart:hash:abcd,2
                    var _subpart = _gcl2.default.sb();
                    var _parts2 = __.getValue(paraname["_subpart"]).split(":");
                    var type = _parts2.shift().toLowerCase().trim();
                    if (_parts2.length) switch (type) {
                      case "list":
                        _parts2 = _parts2[0].split(";");
                        _subpart.append(" SUBPARTITION BY LIST " + type + "SUBPARTITION TEMPLATE(").append(_parts2.map(function (v, i) {
                          return "SUBPARTITION P" + i + " VALUES (" + v.split(",").map(function (v2) {
                            return (0, _isInteger2.default)(v2) ? v2 : "'" + v2.trim('"').trim("'");
                          }).join(",") + ")";
                        }).join(",")).append(")");
                        break;
                      case "hash":
                        _parts2 = _parts2[0].split(/[;,]/g);
                        _subpart.append(" SUBPARTITION BY " + type + " (" + _parts2.shift() + ") subpartitions " + _parts2.shift());
                        break;
                    }
                    subpart = _subpart.clear();
                    _subpart = null;
                  }
                  if (_gcl2.default.isValid(paraname["_part"])) {
                    var _parts3 = __.getValue(paraname["_part"]).split(":");
                    var _type = _parts3.shift().toLowerCase().trim();
                    if (_parts3.length) switch (_type) {
                      case "range":
                        _parts3 = _parts3[0].split(/[;,]/g);
                        sb.append(" partition BY RANGE (" + _parts3.shift() + ") " + subpart + "{").append(_parts3.map(function (v, i) {
                          return "PARTITION P" + i + " VALUES LESS THAN (" + v + ")";
                        }).join(",")).append("}");
                        break;
                      case "list":
                        _parts3 = _parts3[0].split(";");
                        sb.append(" partition BY LIST (" + _parts3.shift() + ") " + subpart + "{").append(_parts3.map(function (v, i) {
                          return "PARTITION P" + i + " VALUES IN (" + v + ")";
                        }).join(",")).append("}");
                        break;
                      case "hash":
                      case "key":
                      case "linear hash":
                        _parts3 = _parts3[0].split(/[;,]/g);
                        sb.append(" partition BY " + _type + " (" + _parts3.shift() + ") " + subpart + " ").append(" PARTITIONS " + (_parts3[0] || 1));
                        break;
                      case "range columns":
                        _parts3 = _parts3[0].split(/[;,]/g);
                        sb.append(" partition BY " + _type + " (" + _parts3.shift() + ") " + subpart + " {").append(_parts3.map(function (v, i) {
                          return " PARTITION P" + i + " VALUES LESS THAN (" + ((0, _isInteger2.default)(v) ? v : "'" + v.trim('"').trim("'") + "'") + ")";
                        }).join(",")).append("}");
                        break;
                      case "list columns":
                        _parts3 = _parts3[0].split(/[;,]/g);
                        sb.append(" partition BY " + _type + " (" + _parts3.shift() + ") {").append(_parts3.map(function (v, i) {
                          return " PARTITION P" + i + " VALUES IN (" + v.split(",").map(function (v2) {
                            return (0, _isInteger2.default)(v2) ? v2 : "'" + v2.trim('"').trim("'") + "'";
                          }).join(",") + ")";
                        }).join(",")).append("}");
                        break;
                    }
                  }
                  sb.append(";select 1 as count;");
                  break;
                case "drop":
                  _database.length && sb.append("use " + _database + ";");
                  sb.append("drop table " + _table2 + ";select 1 as count;");
                  break;
                case "replace":
                case "add":
                  //insert into a (a,b,c) values (?a,?b,?c);select @@IDentity as ID,row_count as count;
                  sb.append(3 == _method.length ? "insert" : "replace");
                  sb.append(" into " + (_database.length ? _database + "." : "") + _table2 + " (");
                  sb.append(that.lstParams(params, function (k, v) {
                    return "`" + k + "`";
                  })).append(")  values (");
                  sb.append(that.lstParams(params, function (k, v) {
                    var val = v && v.value === null ? "_NULL" : __.getValue(v).trim();

                    if (val.indexOf("?_GUID") >= 0) params["_GUID"] = {
                      type: "varchar",
                      isStandard: true,
                      value: _gcl2.default.GUID()
                    };

                    if (val.eq("?_SNOWID")) params["_SNOWID"] = {
                      type: "varchar",
                      isStandard: true,
                      value: _gcl2.default.SNOWID()
                    };

                    if (val.indexOf("?_NULL") >= 0 || val.eq("_NULL")) {
                      params["_NULL"] = {
                        type: "varchar",
                        isStandard: true,
                        value: null
                      };
                      return "null";
                    }
                    if (!val.startsWith("'") && !val.startsWith('"') && !!val.match(/\(|(\?[^,])|\+|\-|\*|\.|\/|`/)) return val;else {
                      v.value = val.trim('"').trim("'");
                      return "?" + k;
                    }
                  })).append(");select @@IDentity as ID,row_count() as count" + (params["_GUID"] ? ',"' + params["_GUID"].value + '" as GUID' : "") + (params["_SNOWID"] ? ',"' + params["_SNOWID"].value + '" as SNOWID' : "") + ";");
                  break;
                case "del":
                  //delete from a where a=1 and b=2 and c=4 and (a=1 or b=2);select row_count() as count;
                  {
                    sb.append("delete ");
                    if (_table2.match(/[<>]?\+|\,/g)) {
                      var delindex = __.tindex.map(function (v) {
                        return !!params[v] ? v : null;
                      }).filter(function (v) {
                        return !!v;
                      }).join(",");
                      if (!delindex) throw new Error("表连接未能说明需要删除的表 譬如a:true");
                      sb.append(delindex);
                    }
                    sb.append(" from " + __.getTable(_database, _table2, params) + " where ");
                    var where = that.getWhere(params, true);
                    if (where.trim().eq("1=1")) throw new Error("不能无条件删除所有数据!");
                    sb.append(where).append(";select row_count() as count;");
                  }
                  break;
                case "truncate":
                  //delete from a where a=1 and b=2 and c=4 and (a=1 or b=2);select row_count() as count;
                  {
                    var _where = that.getWhere(params, true);
                    if (_where.trim().eq("1=1")) throw new Error("不能无条件删除所有数据!");
                    sb.append("truncate table " + (_database.length ? _database + "." : "") + _table2 + " ;select row_count() as count;");
                  }
                  break;
                case "update":
                  {
                    sb.append("update " + __.getTable(_database, _table2.replace(/[<>]?\+/g, ","), params) + " set ");
                    var sbset = _gcl2.default.sb();

                    var _loop = function _loop(_k2) {
                      _k2 = _k2.replace(/;/g, "_");
                      var v = __.getValue(params[_k2]).trim();
                      if (!_k2.startsWith("_") && !_k2.startsWith("$") && !_k2.startsWith("&&") && !_k2.startsWith("||")) sbset.append((_k2.match(/\./) ? _k2 : "`" + _k2 + "`") + (" = " + (!v.startsWith("'") && !v.startsWith('"') && !!v.match(/\(|(\?[^,])|\+|\-|\*|\.|\/|`/) ? "?_null".eq(v) ? "null" : v : v.startsWith("_") ? function () {
                        switch (v.toLowerCase()) {
                          case "_increase":
                            return "ifnull(" + _k2 + ",0)+1";
                          case "_decrease":
                            return "greatest(0,ifnull(" + _k2 + ",0)-1)";
                          case "_null":
                            return "null";
                          default:
                            return "?" + _k2;
                        }
                      }() : function () {
                        params[_k2].value = v.trim('"').trim("'");
                        if (_k2.match(/\./)) {
                          var nk = _k2.replace(/\./g, "_") + _gcl2.default.random();
                          params[nk] = params[_k2];
                          delete params[_k2];
                          _k2 = nk;
                        }
                        return "?" + _k2;
                      }()))).append(",");
                      _k = _k2;
                    };

                    for (var _k in params) {
                      _loop(_k);
                    }
                    sb.append(sbset.clear().trim(",")).append(" where ").append(that.getWhere(params, true)).append(";select row_count() as count;");
                    sbset = null;
                  }
                  break;
                case "select":
                  {
                    //保证两次返回的值一定
                    var params2 = _gcl2.default.merge({}, params);
                    sb.append("select " + (_gcl2.default.isValid(__.getValue(params["_distinct"])) ? "distinct " : ""));
                    var length = sb.toString().length;
                    if (_gcl2.default.isValid(__.getValue(params["_columns"]))) {
                      //对columns进行特殊处理
                      var columns = __.getValue(params["_columns"]);
                      delete params["_columns"];
                      columns.split(",").forEach(function (col) {
                        return params[col.replace(/^[$_?]|\s/g, "")] = {
                          value: true
                        };
                      });
                    }
                    for (var _k3 in params) {
                      if (!_k3.startsWith("_") && !_k3.startsWith("+") && !_k3.startsWith("$") && !_k3.startsWith("&&") && !_k3.startsWith("||")) {
                        var _v = __.getValue(params[_k3]);
                        _k3 = _k3.replace(/;/g, "_");
                        if (!!_v.match(/[\.\?\(\)]/)) sb.append(_v + " as `" + _k3 + "`").append(",");else if (_k3.match(/\./g)) sb.append(_k3).append((_v + "").eq("true") ? "" : " as " + _v + " ").append(",");else sb.append("`" + _k3 + "`").append((_v + "").eq("true") ? "" : " as " + _v + " ").append(",");
                      }
                    }
                    if (length == sb.toString().length) {
                      if (__.isStrict) throw new Error("不能显示所有列");else sb.append("*");
                    } else sb.append(sb.clear().trim(","));
                    params["_lock"] && sb.append(" " + (true === params["_lock"] ? "for update" : params["_lock"]) + " ");
                    var body = " from " + __.getTable(_database, _table2, params) + " ";
                    sb.append(body).append("where " + that.getWhere(params)).append(";");
                    params["_count"] && sb.append("select count(" + (_gcl2.default.isValid(__.getValue(params["_distinct"])) ? "distinct " : "") + "*) as count " + body + " where ").append(that.getWhere(params2, true)).append(";");
                    _gcl2.default.merge(params, params2, true);
                    if (_table2.match(/[\|&]/g)) {
                      //| union & union all
                      var sql = sb.clear().trim(";");
                      var ope = _table2.match(/\|/g) ? "|" : "&";
                      sb.append(_table2.split(ope).map(function (v) {
                        return sql.replace(/\{tablename\}/g, v);
                      }).join(ope.eq("|") ? " union " : " union all ") + ";");
                    }
                  }
                  break;
                case "count":
                  {
                    sb.append("select ").append(__.getValue(paraname["_group"]) + (paraname["_group"] ? "," : "") || "");
                    var _length = sb.toString().length;

                    var i = 1;
                    for (var _k4 in params) {
                      if (!_k4.startsWith("_") && !_k4.startsWith("$") && !_k4.startsWith("&&") && !_k4.startsWith("||")) sb.append("count(" + (_gcl2.default.isValid(__.getValue(params["_distinct"])) ? "distinct " : "")).append(_k4.match(/[\.,\(]/g) ? _k4 : (__.getValue(params[_k4]) + "").match(/[\.\(,]/g) ? __.getValue(params[_k4]) : "`" + _k4 + "`").append(") as " + (_k4.match(/\./g) ? "count" + i++ : _k4) + ",");
                    }

                    if (_length == sb.toString().length) throw new Error("count命令未设置统计列 例如 column1:true");else sb.append(sb.clear().trim(","));

                    var _body = __.getTable(_database, _table2, params);
                    var _where2 = that.getWhere(params);
                    sb.append(" from " + _body + " where ").append(_where2).append(";");
                    params["_count"] && sb.append("select count(*) as count from (" + sb.toString().trim(";") + ") a;");
                    //todo 优化SQL
                  }
                  break;
                case "sum":
                  {
                    sb.append("select ").append(__.getValue(paraname["_group"]) + (paraname["_group"] ? "," : "") || "");
                    var _length2 = sb.toString().length;
                    var i = 1;
                    for (var _k5 in params) {
                      if (!_k5.startsWith("_") && !_k5.startsWith("$") && !_k5.startsWith("&&") && !_k5.startsWith("||")) sb.append("sum(" + (_gcl2.default.isValid(__.getValue(params["_distinct"])) ? "distinct " : "")).append(_k5.match(/[\.,\(]/g) ? _k5 : (__.getValue(params[_k5]) + "").match(/[\.\(,]/g) ? __.getValue(params[_k5]) : "`" + _k5 + "`").append(") as " + (_k5.match(/\./g) ? "count" + i++ : _k5) + ",");
                    }
                    if (_length2 == sb.toString().length) throw new Error("sum命令未设置统计列 例如 column1:true");else sb.append(sb.clear().trim(","));

                    var _body2 = __.getTable(_database, _table2, params);
                    var _where3 = that.getWhere(params);
                    sb.append(" from " + _body2 + " where ").append(_where3).append(";");
                    params["_count"] && sb.append("select count(*) as count from (" + sb.toString().trim(";") + ") a;");
                    //todo 优化SQL
                  }
                  break;
                case "updateevent":
                  {
                    var sbset = _gcl2.default.sb();

                    var _loop2 = function _loop2(_k7) {
                      var v = __.getValue(params[_k7]).trim();
                      if (!_k7.startsWith("_") && !_k7.startsWith("$") && !_k7.startsWith("&&") && !_k7.startsWith("||")) sbset.append((_k7.match(/\./) ? _k7 : "`" + _k7 + "`") + (" = " + (!v.startsWith("'") && !v.startsWith('"') && !!v.match(/\(|(\?[^,])|\+|\-|\*|\.|\/|`/) ? v : v.startsWith("_") ? function () {
                        switch (v.toLowerCase()) {
                          case "_increase":
                            return "ifnull(" + _k7 + ",0)+1";
                          case "_decrease":
                            return "greatest(0,ifnull(" + _k7 + ",0)-1)";
                          case "_null":
                            return "null";
                          default:
                            return "?" + _k7;
                        }
                      }() : function () {
                        params[_k7].value = v.trim('"').trim("'");
                        if (_k7.match(/\./)) {
                          var nk = _k7.replace(/\./g, "_") + _gcl2.default.random();
                          params[nk] = params[_k7];
                          delete params[_k7];
                          _k7 = nk;
                        }
                        return "?" + _k7;
                      }()))).append(",");
                      _k6 = _k7;
                    };

                    for (var _k6 in params) {
                      _loop2(_k6);
                    }
                    var _table = __.getTable(_database, _table2.replace(/[<>]?\+/g, ","), params);
                    // set session group_concat_max_len=102400000;//默认长度是1024
                    // select group_concat('\'',ID,'\'') into @ID from ff_schedulehis where  `ID` = ifnull(?_ID,'');
                    // set @ID = ifnull(@ID,'NULL');//当执行group_concat后,如果没有查到值，@ID会变为null，此时不能直接拼接到 in()里面
                    // SET @sql=concat('select * from ff_schedulehis  where ID in (',@ID,');');
                    // prepare co FROM @sql;execute co;SET @sql2=concat("update ff_schedulehis set `sn` = ?sn where ID in (",@ID,");");prepare co1 FROM @sql2;execute co1;select row_count() as count;execute co;DEALLOCATE PREPARE co;DEALLOCATE PREPARE co1;
                    //预编译命令prepare 后面只能接一个sql;
                    //执行预编译sql 后，记得DEALLOCATE PREPARE co1 (释放资源)
                    sb.append("set session group_concat_max_len=102400000;");
                    sb.append("select group_concat('\\'',ID,'\\'') into @ID from (select ID from ").append(_table).append(" where ").append(that.getWhere(params, 2));
                    sb.append(" ) a;set @ID = ifnull(@ID,'NULL');SET @sql=concat('select * from ").append(_table).append("  where ID in (',@ID,');');prepare co FROM @sql;execute co;");
                    sb.append('SET @sql2=concat("update ').append(_table).append(" set ").append(sbset.clear().trim(",")).append(' where ID in (",@ID,");");prepare co1 FROM @sql2;execute co1;select row_count() as count;execute co;DEALLOCATE PREPARE co;DEALLOCATE PREPARE co1;');
                    sbset = null;
                    //console.log('sql', sb.toString());
                  }
                  break;
                case "replaceevent":
                case "addevent":
                  //insert into a (a,b,c) values (?a,?b,?c);select @@IDentity as ID,row_count as count;
                  //set @count=row_count();set @ID=CASE WHEN @@IDentity THEN @@IDentity ELSE _GUID的值 END;select @@IDentity as ID,@count as count [,_GUID as GUID]
                  //;select * from 表 where @count>0 and ID=@ID;
                  {
                    var _table3 = __.getTable(_database, _table2.replace(/[<>]?\+/g, ","), params);
                    sb.append(8 == _method.length() ? "insert" : "select * from " + _table3 + " where ID=@ID;replace");
                    sb.append(" into ").append(_table3).append("(");
                    sb.append(that.lstParams(params, function (k, v) {
                      return "`" + k + "`";
                    })).append(")  values (");
                    sb.append(that.lstParams(params, function (k, v) {
                      var val = v && v.value === null ? "_NULL" : __.getValue(v).trim();

                      if (val.indexOf("?_GUID") >= 0) params["_GUID"] = {
                        type: "varchar",
                        isStandard: true,
                        value: _gcl2.default.GUID()
                      };

                      if (val.indexOf("?_SNOWID") >= 0) params["_SNOWID"] = {
                        type: "varchar",
                        isStandard: true,
                        value: _gcl2.default.SNOWID()
                      };

                      if (val.indexOf("?_NULL") >= 0 || val.eq("_NULL")) {
                        params["_NULL"] = {
                          type: "varchar",
                          isStandard: true,
                          value: null
                        };
                        return "null";
                      }
                      if (!val.startsWith("'") && !val.startsWith('"') && !!val.match(/\(|(\?[^,])|\+|\-|\*|\.|\/|`/)) return val;else {
                        v.value = val.trim('"').trim("'");
                        return "?" + k;
                      }
                    })).append(");set @count=row_count();set @ID=CASE WHEN @@IDentity THEN @@IDentity ELSE ").append(params["_GUID"] ? '"' + params["_GUID"].value + '"' : "NULL").append(params["_SNOWID"] ? '"' + params["_SNOWID"].value + '"' : "NULL").append(" END;select @ID as ID,@count as count").append(params["_GUID"] ? ',"' + params["_GUID"].value + '" as GUID' : "").append(params["_SNOWID"] ? ',"' + params["_SNOWID"].value + '" as SNOWID' : "");
                    sb.append(";select * from ").append(_table3).append(" where @count>0 and ID=@ID;");
                    //console.log('add', sb.toString());
                  }
                  break;
                case "delevent":
                  //select * from 表 where 条件;
                  //delete from a where a=1 and b=2 and c=4 and (a=1 or b=2);select row_count() as count;
                  //select row_count() as count;
                  //或者是
                  //set session group_concat_max_len=102400000;select group_concat('\'',ID,'\'') into @ID from ff_schedule where  `ID` = ifnull(?_ID,'');set @ID = ifnull(@ID,'NULL');SET @sql=concat('select * from ff_schedule  where ID in (',@ID,');');prepare co FROM @sql;execute co;SET @sql=concat('delete from ff_schedule  where ID in (',@ID,');');prepare co FROM @sql;execute co;select row_count() as count;DEALLOCATE PREPARE co;
                  {
                    var _where4 = that.getWhere(params, 2);
                    if (_where4.trim().eq("1=1")) throw new Error("不能无条件删除所有数据!");
                    var _table4 = __.getTable(_database, _table2.replace(/[<>]?\+/g, ","), params);
                    sb.append("set session group_concat_max_len=102400000;");
                    sb.append("select group_concat('\\'',ID,'\\'') into @ID from (select ID from ").append(_table4).append(" where ").append(_where4);
                    sb.append(" ) a;set @ID = ifnull(@ID,'NULL');SET @sql=concat('select * from ").append(_table4).append("  where ID in (',@ID,');');prepare co FROM @sql;execute co;");
                    sb.append("SET @sql=concat('delete from ").append(_table4).append("  where ID in (',@ID,');');prepare co FROM @sql;execute co;select row_count() as count;DEALLOCATE PREPARE co;");
                    //console.log('del', sb.toString());
                  }

                  // {
                  //     const where = that.getWhere(params, true);
                  //     let _table = __.getTable(database, table.replace(/[<>]?\+/g, ','), params);
                  //     sb.append("select * from ").append(_table).append(" where").append(where);
                  //     sb.append(';delete ');
                  //     if (table.match(/[<>]?\+|\,/g)) {
                  //         var delindex = __.tindex.map(function (v) {
                  //             return !!params[v] ? v : null;
                  //         }).filter(function (v) { return !!v; }).join(',');
                  //         if (!delindex) throw new Error('表连接未能说明需要删除的表 譬如a:true');
                  //         sb.append(delindex);
                  //     }
                  //     sb.append(" from ").append(_table).append(" where ");
                  //     if (where.trim().eq('1=1')) throw new Error('不能无条件删除所有数据!');
                  //     sb.append(where).append(";select row_count() as count;");
                  //     console.log('del', sb.toString());
                  // }
                  break;
                default:
                  throw new Error("未识别的命令" + command);
              }
            }
            break;
          case 2:
            /**
             * 库名/操作
             * create 新建库
             * drop 删除库
             */
            {
              var _database2 = cmds[0].replace(/^[~_\.]$/, ""),
                  _method2 = cmds[1];
              if (!_database2.length) throw new Error("请输入库名!");
              switch (_method2.toLowerCase()) {
                case "create":
                  sb.append("create DATABASE if not exists " + _database2 + " CHARACTER SET utf8 COLLATE utf8_general_ci;select 1 as count;");
                  break;
                case "drop":
                  sb.append("DROP DATABASE IF EXISTS " + _database2 + ";select 1 as count;");
                  break;
                default:
                  throw new Error("未识别的命令" + command);
              }
            }
            break;
          default:
            throw new Error("无法处理命令类型:" + command + "!请按照[库].表[.字段|索引].操作 方式设置命令!");
        }
        cmd.command = sb.clear();
        if ("true".eq(__.getValue(paraname["_debug"]))) console.log("mysql", cmd.command, cmd.params);
      } finally {
        sb = null;
      }
    }
  }]);
  return EMBMySQLConverter;
}();

exports.default = {
  EMBMySQLConverter: EMBMySQLConverter
};

var pri = _gcl2.default.pris();
//# sourceMappingURL=EMBMySQLConverter.js.map